import 'package:dio/dio.dart';
import 'package:injectable/injectable.dart';
import 'package:logger/logger.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:suga_core/suga_core.dart';

@module
abstract class RegisterModule {
  @singleton
  @preResolve
  Future<SharedPreferences> getSharePreferences() async => SharedPreferences.getInstance();

  @singleton
  @preResolve
  HttpClient getHttpClient(Oauth2Manager oauth2Manager) {
    final HttpClientConfig config = HttpClientConfig(
      dioOptions: BaseOptions(
        baseUrl: "http://dev.sugamobile.com:26124",
        connectTimeout: 30000,
        receiveTimeout: 30000,
      ),
      logger: Logger(
        level: Level.debug,
        printer: SimplePrinter(),
      ),
      oauth2Manager: oauth2Manager,
      verbose: true,
    );
    return HttpClient(config);
  }

  @singleton
  @preResolve
  Oauth2Manager getOauth2Manager(SharedPreferences prefs) {
    final Oauth2ManagerConfig config = Oauth2ManagerConfig(
      authorizationEndpoint: Uri.parse("http://dev.sugamobile.com:26124/oauth/token"),
      credentialStorage: OAuth2CredentialsStorage(prefs),
      secret: "FqJfCb0CmPUv4OMeE8lTIoTE0SfDqJ8V5kpnREQM",
      identifier: "2",
      logger: Logger(
        level: Level.debug,
        printer: SimplePrinter(),
      ),
    );
    return Oauth2Manager(config);
  }
}
