import 'package:injectable/injectable.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:suga_core/suga_core.dart';

@lazySingleton
class CountStorage extends Storage<int> {
  CountStorage(SharedPreferences prefs) : super(prefs, 'count');

  @override
  int get({int defaultValue}) {
    return prefs.getInt(key);
  }

  @override
  void set(int value) {
    prefs.setInt(key, value);
  }
}
