import 'package:dio/dio.dart';
import 'package:logger/logger.dart';
import 'package:suga_core/src/oauth2/oauth2_manager.dart';

typedef UnauthorizedResponseHandler = void Function();

class HttpClientConfig {
  BaseOptions dioOptions;

  Logger logger;

  bool verbose;

  UnauthorizedResponseHandler unauthorizedResponseHandler;

  Oauth2Manager oauth2Manager;

  List<Interceptor> extraInterceptors;

  Map<String, dynamic> extraHeaders;

  HttpClientConfig({this.dioOptions, this.logger, this.verbose = false, this.unauthorizedResponseHandler, this.oauth2Manager, this.extraInterceptors, this.extraHeaders});
}
